<?

/**
 * server.php
 * 
 * This file contains additional web services called by the studip om plugin   
 * 
 * Version: 0.1
 * Date: 29.06.2010
 * Copyright: Heiko Dostert (dostert@uni-trier.de), Jrg Rpke (roepke@uni-trier.de)
 * License: Eclipse Public License 1.0 (http://www.eclipse.org/legal/epl-v10.html)
 * 
 * @version 1.0.5 - 20.12.2011 - Paul C. Sommerhoff <somm4702@uni-trier.de>
 * @version 1.1.0 - 06.03.2012 - Paul C. Sommerhoff <somm4702@uni-trier.de>
 */


include("server_config.php");


$server = new SoapServer(NULL, $options);


$server->addFunction("getCapacity");
$server->addFunction("setRoom");
$server->addFunction("deleteRoom");
$server->addFunction("getRefRecords");
$server->addFunction("getRoomSize");
$server->handle();



// Datenbank
// lesen: $read-> TRUE
function myDB($sql_query, $read = FALSE, $array = FALSE)
{
	global $MAIL_ADMIN, $SUBJECT, $DB_HOST, $DB_USER, $DB_PASSWORD, $DB_DATABASE;
	
	$my_rows = NULL;
	$connection = mysql_connect($DB_HOST, $DB_USER, $DB_PASSWORD);
	
	if (!$connection) {
		die(mail($MAIL_ADMIN, $SUBJECT, 'Keine DB-Verbindung mglich: ' . mysql_error()));
	}
	
	mysql_select_db($DB_DATABASE);
	
	mysql_query('SET NAMES = utf8');

	$result = mysql_query($sql_query);
	
	
	if($read == TRUE && $array == TRUE){
		$my_rows = array();
		while ($row = mysql_fetch_assoc($result)) {
   			$my_rows[] = $row;  
		}
		$result = $my_rows;
	}
	elseif($read == TRUE){
		$result = mysql_result($result, 0);
	}
	
	mysql_close($connection);
	
	return $result;
}



// Freie Kapazitaet des Servers ermitteln
// Berechnung: Tabelle:rooms:numberOfPartizipants - $MAXcAPACITY
function getCapacity($myStartTime, $myEndTime, $my_pwd)
{
	global $MAXcAPACITY, $PWD, $RESERVATION_PERMITTED;
	
	if($my_pwd != $PWD)
		return FALSE;
	
	$capacity = 0;
	//$myStartTime = $this->convertTimestamp($myStartTime);
	//$myEndTime = $this->convertTimestamp($myEndTime);
	
	if(!$RESERVATION_PERMITTED)
		return 0;
	
	$sql_query  = "SELECT SUM(opm.numberOfPartizipants) AS summe ";
	$sql_query .= "FROM  rooms AS opm, rooms_studip AS studip ";
	$sql_query .= "WHERE ((studip.startTime <= '$myEndTime' AND studip.endTime >= '$myStartTime')) ";
	$sql_query .= "AND studip.rooms_id = opm.rooms_id";
	
	$capacity = $MAXcAPACITY - myDB($sql_query, TRUE);
	
	if($capacity < 0) {
		$capacity = 0;
	}
	
	return $capacity;
}

// Wird ein Raum angelegt, so muss auch die Tabelle rooms_studip 
// befuellt werden. Diese Tabelle "erweitert" die Tabelle rooms um den 
function setRoom($rooms_id, $startTime, $endTime, $archiveTime, $installationName, $my_pwd)
{
	global $PWD, $ABSOLUTE_PATH, $MAIL_ADMIN, $DISKSPACE_TOLERANCE, $soap_host;
	
	if(disk_free_space($ABSOLUTE_PATH."/upload/") < $DISKSPACE_TOLERANCE) 
		mail($MAIL_ADMIN, $soap_host.' - Warnung', 'Freier Festplattenplatz fr OM-Uploads liegt bei: '.disk_free_space($ABSOLUTE_PATH."/upload/").' bytes');	
	
	if($my_pwd != $PWD)
		return FALSE;
	$installationName = utf8_decode($installationName);	
	$sql_query  = "REPLACE INTO rooms_studip SET ";
	$sql_query .= "rooms_id = '$rooms_id', ";
	$sql_query .= "startTime = '$startTime', ";
	$sql_query .= "endTime = '$endTime', ";
	$sql_query .= "archiveTime = '$archiveTime', ";
	$sql_query .= "installationName = '$installationName'";

	myDB($sql_query);
	
	// Mikrofon-Hilfe einbauen
	if(!file_exists($ABSOLUTE_PATH."/upload/files")) {
		exec("mkdir ".$ABSOLUTE_PATH."/upload/files");
		exec("chmod g+rw ".$ABSOLUTE_PATH."/upload/files");
	}
	exec("mkdir ".$ABSOLUTE_PATH."/upload/files/MikrofonHilfe-".$rooms_id);
	exec("cp MikrofonHilfe/* ".$ABSOLUTE_PATH."/upload/files/MikrofonHilfe-".$rooms_id);
	exec("mv ".$ABSOLUTE_PATH."/upload/files/MikrofonHilfe-".$rooms_id."/MikrofonHilfe.pdf ".$ABSOLUTE_PATH."/upload/files/MikrofonHilfe-".$rooms_id."/MikrofonHilfe-".$rooms_id.".pdf");
	exec("mv ".$ABSOLUTE_PATH."/upload/files/MikrofonHilfe-".$rooms_id."/MikrofonHilfe.swf ".$ABSOLUTE_PATH."/upload/files/MikrofonHilfe-".$rooms_id."/MikrofonHilfe-".$rooms_id.".swf");
	exec("chmod -R g+w ".$ABSOLUTE_PATH."/upload/files/MikrofonHilfe-".$rooms_id);
	//exec("chgrp -R red5 ".$ABSOLUTE_PATH."/upload/files/MikrofonHilfe-".$rooms_id);
	
	// Es muss auch die XML-Datei library.xml angepasst werden, damit alles funktioniert
	$text = '<?xml version="1.0" encoding="UTF-8"?>'."\n".'<presentation><originalDocument lastmod="1309271245000" size="101600">MikrofonHilfe-'.$rooms_id.'.pdf</originalDocument><swfDocument lastmod="1309271245000" size="101600">MikrofonHilfe-'.$rooms_id.'.swf</swfDocument><thumbs><thumb lastmod="1309271245000" size="1998">_thumb_page-0000.jpg</thumb></thumbs></presentation>';
	$dateiname = $ABSOLUTE_PATH."/upload/files/MikrofonHilfe-".$rooms_id."/library.xml";
	$handler = fOpen($dateiname , "w+");
	fWrite($handler , $text);
	fClose($handler);
	
	if(myDB("SELECT count(*) FROM `fileexploreritem`", TRUE) > 0)
		$id = myDB("SELECT max(fileexploreritem_id)+1 FROM `fileexploreritem`", TRUE);
	else
		$id = 1;
	$sql_query = "INSERT INTO fileexploreritem SET fileexploreritem_id = $id, filename = 'MikrofonHilfe.pdf', filehash = 'MikrofonHilfe-$rooms_id', owner_id = NULL, room_id = $rooms_id, inserted = Now(), updated = Now(), parent_fileexploreritem_id = 0, is_folder = 0, is_image = 0, is_video = null, is_presentation = 1,	inserted_by = 0, deleted = false, filesize = NULL, flv_width = NULL, flv_height = NULL, preview_image = NULL, wml_file_path = '', is_stored_wml_file = 0, is_chart = 0";
	myDB($sql_query);
	
	return TRUE;
}

// Wird ein Raum geloescht, muss er auch aus der Tabelle rooms_id geloescht werden:
function deleteRoom($rooms_id, $my_pwd){
	global $PWD, /*$INSTALLATION,*/ $ABSOLUTE_PATH;
	if($my_pwd != $PWD)
		return FALSE;
	$sql_query = "DELETE FROM rooms_studip WHERE rooms_id = $rooms_id";	
	myDB($sql_query);
	$sql_query = "DELETE FROM soaplogin WHERE room_id = $rooms_id";	
	myDB($sql_query);
	$sql_query = "DELETE FROM rooms WHERE rooms_id = $rooms_id";	
	myDB($sql_query);
	
	//Auch sonstige Hinterlassenschaften beseitigen:
	//ACHTUNG: Webservice braucht Schreibrechte fuer relevante Ordner! 
	$sql_query = "SELECT * FROM flvrecording WHERE room_id = $rooms_id";
	$result = myDB($sql_query);
	while($row = mysql_fetch_assoc($result)){
		$alternate_download = $row['alternate_download'];
		$filehash = $row['filehash'];
		$preview_image = $row['preview_image'];
		exec("rm -f '$ABSOLUTE_PATH/streams/hibernate/$alternate_download'");
		//$test .= "rm -f '$ABSOLUTE_PATH/streams/hibernate/$alternate_download'\n";
		exec("rm -f '$ABSOLUTE_PATH/streams/hibernate/$filehash'");
		exec("rm -f '$ABSOLUTE_PATH/streams/hibernate/$preview_image'");
		$sql_query = "DELETE FROM flvrecording_log WHERE flvrecording_id = ".$row['flvrecording_id'];
		myDB($sql_query);
		$sql_query = "SELECT * FROM flvrecording_metadata WHERE flvrecording_id = ".$row['flvrecording_id'];
		$result2 = myDB($sql_query);
		while($row2 = mysql_fetch_assoc($result2)){
			$sql_query = "DELETE FROM flvrecording_meta_delta WHERE flvrecording_metadata_id = ".$row2['flvrecording_metadata_id'];
			//$test .= $sql_query."\n";			
			myDB($sql_query);
		}
		$sql_query = "DELETE FROM flvrecording_metadata WHERE flvrecording_id = ".$row['flvrecording_id'];
		//$test .= $sql_query."\n";
		myDB($sql_query);		
	}
	$sql_query = "DELETE FROM flvrecording WHERE room_id = $rooms_id";
	$result = myDB($sql_query);
	
	// ab OM 1.7
	$sql_query = "SELECT * FROM fileexploreritem WHERE room_id = $rooms_id";
	$result = myDB($sql_query);
	while($row = mysql_fetch_assoc($result)){
		if($row['is_folder'] == 0) {
			$filehash = $row['filehash'];
			exec("rm -rf '$ABSOLUTE_PATH/upload/files/$filehash'");
			exec("rm -rf '$ABSOLUTE_PATH/upload/files/_thumb_$filehash'");
		}
	}
	$sql_query = "DELETE FROM fileexploreritem WHERE room_id = $rooms_id";
	$result = myDB($sql_query);
	
	exec("rm -rf '$ABSOLUTE_PATH/streams/$rooms_id'");
	exec("rm -rf '$ABSOLUTE_PATH/upload/$rooms_id'");
	exec("rm -rf '$ABSOLUTE_PATH/uploadtemp/$rooms_id'");	
	
	// eventuell Mail an Admin fr Wartungsarbeiten
	if(!$RESERVATION_PERMITTED) {
		$sql_query = "SELECT count(*) FROM rooms_studip";
		$result = myDB($sql_query, true);
		
		if ($result == 0) {
			mail($MAIL_ADMIN, $soap_host.' - Letzter Raum wurde gelscht', 'Es wurde der letzte Raum von portaLE auf Server '.$soap_host.' gelscht und die Raum-Neureservierung ist derzeit nicht erlaubt. Der Server ist somit bereit fr eventuelle Wartungsarbeiten.');
		}
	}
	
	return TRUE;	
}

// Aufraeumen der Tabelle "rooms_studip" 
function clean($my_pwd)
{
	global $PWD, $ABSOLUTE_PATH;
	
	if($my_pwd != $PWD)
		return FALSE;
	
	$sql_query  = "SELECT rooms_id FROM rooms_studip ";
	$sql_query .= "WHERE archiveTime < NOW()";
	$result = myDB($sql_query, TRUE, TRUE);
	$log_array = array();
	
	if(is_array($result)){
		foreach($result AS $tupel){
			deleteRoom($tupel['rooms_id'], $PWD);
			$log_array[] = $tupel['rooms_id'];
		}
	}
	
	// Audio-Testdateien entfernen
	$dir = $ABSOLUTE_PATH . '/streams/hibernate/';
	if ($handle = opendir($dir)) {
	    while (false !== ($file = readdir($handle))) {
	        if ((substr($file, 0, 10) == 'TEST_SETUP') && (filemtime($dir.$file) < time() - 60 * 60)) {
	        	unlink($dir.$file);
	        }
	    }
		closedir($handle);
	}

	// delete temporary files and users
	$sql_query = "SELECT * FROM users ";
	$sql_query .= "WHERE (externalUserId/10000 < UNIX_TIMESTAMP()-60*60*24) AND (externalUserType IS NOT NULL)";
	$result = myDB($sql_query, TRUE, TRUE);
	foreach($result AS $tupel){
		$sql_query2 = "SELECT fileexploreritem_id,filehash FROM fileexploreritem WHERE owner_id = '" . $tupel['user_id']. "'";
		$result2 = myDB($sql_query2, TRUE, TRUE);
		foreach($result2 AS $tupel2){
			$sql_query_del = "DELETE FROM fileexploreritem WHERE fileexploreritem_id = '" . $tupel2['fileexploreritem_id'] . "'";
			$result_del = myDB($sql_query_del);
			$filehash = $tupel2['filehash'];
			exec("rm -rf '$ABSOLUTE_PATH/upload/files/$filehash'");
			exec("rm -rf '$ABSOLUTE_PATH/upload/files/_thumb_$filehash'");
		}
		$sql_query_del2 = "DELETE FROM users WHERE user_id = '" . $tupel['user_id'] . "'";
		$result_del2 = myDB($sql_query_del2);
	}
	
	return $log_array;
}

// Liefert alle Referenzen zu den Aufzeichnungen eines Raumes
function getRefRecords($room_id, $my_pwd) {
	
	global $PWD;
	
	if($my_pwd != $PWD)
		return FALSE;
	
	$sql_query = "SELECT flvrecording_id, alternate_download, record_start, record_end FROM flvrecording WHERE room_id = '$room_id' ORDER BY record_start";
	$records = myDB($sql_query, TRUE, TRUE);
	$result = array();
	foreach($records AS $record)
		$result[] = array('id' => $record['flvrecording_id'], 'file' => $record['alternate_download'], 'start' => $record['record_start'], 'end' => $record['record_end']);

	return $result;
	
}

function getRoomSize($room_id, $my_pwd){
	
	global $PWD;
	
	if($my_pwd != $PWD)
		return FALSE;
		
	$sql_query ="SELECT count(*) as summe FROM conferencelog INNER JOIN conferencelogtype ON conferencelog.conferencelogtype_id = conferencelogtype.conferencelogtype_id WHERE room_id = $room_id AND conferencelogtype.eventtype = 'roomEnter' AND user_id IS NOT NULL";
	$in = myDB($sql_query, TRUE);
	$sql_query ="SELECT count(*) as summe FROM conferencelog INNER JOIN conferencelogtype ON conferencelog.conferencelogtype_id = conferencelogtype.conferencelogtype_id WHERE room_id = $room_id AND conferencelogtype.eventtype = 'roomLeave' AND user_id IS NOT NULL";
	$out = myDB($sql_query, TRUE);
	return ($in - $out);
//	return $room_id;
}

// Entfernt alle Teilnehmer aus abgelaufenen Raeumen:
function kickAllUsersInFinishedRooms($my_pwd){
		global $PWD, $soap_host, $soap_port, $soap_admin, $soap_admin_pw;

		if($my_pwd != $PWD)
			return FALSE;
		
		//Verbindung zu Om aufbauen: 
		try{
			$client_userService = new SoapClient("http://$soap_host:$soap_port/openmeetings/services/UserService?wsdl");
			$result = $client_userService->getSession();
		}
		catch(SoapFault $fault){
			return FALSE;
		}
		$session_id = $result->return->session_id;
		$params = array(
			'SID' => $session_id,
			'username' => $soap_admin,
			'userpass' => $soap_admin_pw
		);
		try{
			$result = $client_userService->loginUser($params);
		}
		catch(SoapFault $fault){
			return FALSE;
		}
		
		//In Db nach abgelaufenen Raeumen suchen: 
		$sql_query =  'SELECT rooms_id FROM rooms_studip WHERE endTime < Now() AND kicked_users=0';
		$results = myDB($sql_query, TRUE, TRUE);
		
		//Fuer alle gefundenen Raeume ausfuehren:
		$i = 0;
		foreach($results AS $result){
  			$params = array(
				'SID_Admin' => $session_id,
				'room_id' => $result['rooms_id']
  				);
			 /*$params = array(
				'SID' => $session_id,
				'room_id' => $result['rooms_id'],
				'status' => TRUE
  				);*/
  			try{
				
				$client_roomService = new SoapClient("http://$soap_host:$soap_port/openmeetings/services/RoomService?wsdl");
				$client_roomService->kickUser($params);
				//$client_roomService->closeRoom($params);
				
				//sleep(5);
				//$params['status'] = FALSE;
				//$client_roomService->closeRoom($params);
				
				$sql_query = 'UPDATE rooms_studip SET kicked_users=1 WHERE rooms_id='.$result['rooms_id'];
				myDB($sql_query);
  			}
  			catch(SoapFault $fault){
	  			return false;
  			}
  			$i++;
  		}
  		return $i;
}
?>