
<?php

/**
 * waitingroom.php
 * 
 * This file contains the the template of the waiting room
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * @author Heiko Dostert <dosterth@uni-trier.de>
 * @package portaLE
 * @copyright Universitt Trier, Koordinationsstelle E-Learning, 2010
 * @version 1.0.0
 * @version 1.0.2 - 22.11.2010 - Jrg Rpke <roepke@uni-trier.de>
 */

?>

<script type="text/javascript">

window.setInterval("getWaitingList()", <?php echo (WAITINGROOM_REFRESH_PERIOD*1000);?>);

function getWaitingList(){
	STUDIP.ajax_indicator = false;
	var myAjax = new Ajax.Request(
  		"<?php echo $pluginPath; ?>/updateWaitingroom.php?&id=<?= Request::int('id');?>",
  	{ method: 'get', onSuccess: updateWaitingList }
	);
	STUDIP.ajax_indicator = true;
}

function updateWaitingList( originalRequest ) {
	if(originalRequest.responseText.evalJSON().time != document.getElementById('timestamp').value)
		window.location.href='<?php echo $reloadLink.'&action=waitingroom&id='.REQUEST::int('id'); /*if(isset($ticket)) echo "&ticket=$ticket";*/?>';
}

</script>

<input type="hidden" name="time" id="timestamp" value="<?php echo $time;?>"/>


<div style="padding:0 1.5em 1.5em 1.5em">
<h3>Wartezimmer zum virtuellen Raum <i><?php echo $classroom['title']; ?></i></h3>
<b>DozentIn: </b><?php echo $classroom['firstname'].' '.$classroom['lastname']?><br/>
<b>Beginn: </b><?php echo date("d.m.Y, G:i",strtotime($classroom['date'])); ?> Uhr<br/>
<b>Dauer: </b><?php echo $classroom['length']/60; ?> Minuten
<br/><br/>

<?php if(!empty($classroom['message']))
	echo "<b>Mitteilung DozentIn:<br/></b><font color=\"red\"  size=\"+2\"><em>".$classroom['message']."</em></font>";
?>

</div>
<div id="waitingList">
<table class="steel1" style="width: 100%;" cellpadding="2" cellspacing="0">
	<colgroup>
		<col width="10%"/>
		<col width="50%"/>
		<col width="20%"/>
		<col width="20%"/>
	</colgroup>
	<thead valign="middle">
		<tr class=\"steelgraulight\" align="left" valign="middle">
			<th>Position</th>
			<th>Name</th>
			<th>Status</th>
			<th></th>
		</tr>
	</thead>
	<tbody vaign="middle">

<?php
	$count = 0;
	$cellColor = "steelgraulight";
	foreach($waitingList AS $waitingPerson){
		$cellColor = ($cellColor=="steelgraulight")?'':'steelgraulight';
		$count++;
		echo "<tr class=\"$cellColor\" valign=\"middle\">";
		echo "<td>";
		if($waitingPerson->user_id == $userId)
			echo "<b><font color=\"green\">";
		echo "$count";
		if($waitingPerson->user_id == $userId)
			echo "</font></b>";		
		echo "</td><td valign=\"middle\">";?>
		<?= Avatar::getAvatar($waitingPerson->user_id)->getImageTag(Avatar::SMALL) ?>
		<?php
		if($waitingPerson->user_id == $userId)
			echo "<b><font color=\"green\">";
		echo $waitingPerson->firstname." ".$waitingPerson->lastname."</td>";
		echo "<td>";
		if($waitingPerson->user_id == $userId)
			echo "</font></b>";
		if($hasTeacherPermission || $waitingPerson->user_id == $userId){?>
				<form action="<?php echo $link;?>" method="POST">
					<input type="hidden" name="id" value="<?= REQUEST::int('id');?>">
					<input type="hidden" name="user_id" value="<?php echo $waitingPerson->user_id;?>">
		<?php
		}
		if($waitingPerson->activated){
			echo "<font color=\"green\">"._("Zutritt wurde gewhrt")."</font></td>";
			if($hasTeacherPermission){
		?>
			<td align = "right" valign="middle">
				<?=makebutton('entfernen', 'input', _('Person entfernen'), 'delete_person');?>
			</td>
					
		<?php
			}
			elseif($waitingPerson->user_id == $userId){
		?>
			<td align = "right" valign="middle">
				<input class="button" type="image" src="<?=$pluginPath?>/images/verlassen_button.png"  alt="Wartezimmer verlassen" title="Wartezimmer verlassen" name="delete_person" >
			</td>
		</tr>
					
		<?php
			}
			else
				echo "<td></td></tr>";
		}
		else{  //!$waitingPerson->activated
			if($waitingPerson->user_id == $userId)
				echo "<b><font color=\"green\">";
			echo _("Wartet auf Zutritt");
			if($waitingPerson->user_id == $userId)
				echo "</font></b>";
			echo "</td>";
		?>
		<td align="right" valign="bottom">
		<?php
			if($hasTeacherPermission){
		?>
			<input class="button" type="image" src="<?=$pluginPath?>/images/aufrufen_button.png"  alt="Zutritt zu virtuellem Raum gew&auml;hren" title="Zutritt zu virtuellem Raum gew&auml;hren" name="allow_entry" >
			<?php
				echo "</form>";
			}
			elseif($waitingPerson->user_id == $userId){
		?>
		<input class="button" type="image" src="<?=$pluginPath?>/images/verlassen_button.png"  alt="Wartezimmer verlassen" title="Wartezimmer verlassen" name="delete_person" >
			<?php
				echo "</form>";
			}
			echo "</td></tr>";
		}
	}
	echo "</tbody></table></div>";
	StudIPTemplateEngine::createInfoboxTableCell();
	print_infobox($infobox['text'], $infobox['picture']);
	StudIPTemplateEngine::endInfoBoxTableCell();
?>
</tbody>